> For the complete documentation index, see [llms.txt](https://docs.kasko.io/kasko-frontend-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kasko.io/kasko-frontend-documentation/snippets/reset-input-state.md).

# Reset input state

Extending input state with `set-input-state` event is not enough when some input field should be removed from input.

`set-input-state` only extends existing input, this means that when we have input `{first_name: "John"}` and we extend it with `{last_name: "Doe"}` we get `{first_name: "John", last_name: "Doe"}`. However `reset-input-state` fully overwrites whole input state with event payload, meaning in previous example we get `{last_name: "Doe"}` as final input state.

Useful use case for this is to save and reset input state in flow. This snippet saves state when user gets to `"claim-modules"` screen. And resets input value whenever `input.data.module` state value changes.

```ts
export function customService(kasko) {
  let savedInput;

  function routeChangedHandler({ current }) {
    if (current?.path !== 'claim-modules') {
      return;
    }

    // Save current input state
    savedInput = kasko.getState('input');

    // Stop listening after input is saved
    kasko.removeEventListener('route-changed', routeChangedHandler);
  }

  kasko.addEventListener('route-changed', routeChangedHandler);

  kasko.addEventListener(
    'state-changed',
    (module) => {
      if (!module) {
        return;
      }

      if (savedInput) {
        kasko.dispatchEvent('reset-state-input', {
          module,
          ...savedInput,
        });
      }

      // Do some extra logic or events
    },
    { slice: 'input.data.module' },
  );
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.kasko.io/kasko-frontend-documentation/snippets/reset-input-state.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
